/***************************************************************************
                          global_types.h  -  description
                             -------------------
    begin                : Sat Feb 9 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef GLOBAL_TYPES_H
#define GLOBAL_TYPES_H
#include <ClanLib/core.h>
#include <ClanLib/display.h>
#include <ClanLib/application.h>
#include <ClanLib/sound.h>
#include <ClanLib/png.h>
#include <ClanLib/jpeg.h>



//thanks to the Clanbomber Developers :)
#define PLAY(sample) \
{ \
	CL_SoundBuffer_Session s((sample)->prepare());\
  s.add_filter(new CL_EchoFilter(10*1024), true); \
	s.set_pan( (x-512) / 512.0f );\
	s.play(); \
}

/**
  *@author funthing (Matthias Zisler)
  */

typedef enum
{
 LEFT,
 RIGHT,
 UP,
 DOWN,
 STOPPED
}DirType;

typedef enum
{
 AQUA,
 LAVA,
 JUNGLE,
 ICE,
 TECH
}WorldType;

typedef enum
{
 TOOL,
 MONK,
 PLAYER,
 EFFECT,
 DUMMYG,
 TRAP,
 BEFUDLEMENTGAS,
 HEAP,
 BSLIME,
 ACID,
 LASERTRIPMINE,
 BOMB,
 BIGBOMB,
 CBOMB,
 GASCLOUD
}GameobjectType;

typedef enum
{
 TTRAP,
 TBEFUDLEMENTGAS,
 TPICKAXE,
 TJACKHAMMER,
 TSLIMEBUCKET,
 TACID,
 TSPEED,
 TKEYRED,
 TKEYGREEN,
 TEXPLODER,
 TLIFE,
 TSYRINGE,
 TLASERTRIPMINE,
 TBOMB,
 TBIGBOMB,
 TCBOMB,
 TGOLD,
 NONE
}ToolType;

typedef enum
{
 NORMAL,
 CONCRETE,
 FALLING,
 TELEPORTER,
 SLIME,
 MOVE,
 HIDEOUT,
 BAR,
 LADDER,
 WATER,
 ONCE,
 EMPTY,
 DUMMY,
 DOORR,
 DOORG,
 DNORM
}MaptileType;

typedef enum
{
 LABEL,
 BUTTON,
 CHECKER,
 WHEEL,
 ARROW
}GuiType;

typedef enum
{
 ONEPLAYER,
 TWOPLAYER,
 CONFIG
}SubType;

int ran(int max);
void toggle(bool &b);
float distance(int x, int y, int _x, int _y);
const int frame_offset=32;

using namespace std;
#endif
