/***************************************************************************
                          maptile_teleporter.cpp  -  description
                             -------------------
    begin                : Mon Feb 25 2002
    copyright            : (C) 2002 by funthing (Matthias Zisler)
    email                : matthias@zislers.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "maptile_teleporter.h"
#include "resources.h"
#include "map.h"
#include "game.h"
#include "map_sample.h"
#include "player.h"
#include "sprite.h"
#include "timer.h"
#include "monk.h"

Maptile_teleporter::Maptile_teleporter(int _x, int _y, int _id, int _did, WorldType _wt, Map* _map) : Maptile(_x, _y, _wt, _map)
{
	blocking=false;
	fallt=true;
	mt=TELEPORTER;
	id=_id;
	did=_did;
	connected=false;

	sprite=new Sprite(Resources::Tiles(), 0.1f, 28, 32, 32);
	sprite->set_loop(false);
}
Maptile_teleporter::~Maptile_teleporter()
{
}
int Maptile_teleporter::get_id()
{
	return id;
}
void Maptile_teleporter::show()
{
	sprite->put_screen(x, y);
}
void Maptile_teleporter::act()
{
	if(connected)
	{
		if(map->game->sample->p1->map_x(16)==x && map->game->sample->p1->map_y(16)==y && map->game->sample->p1->ported()==false)
		{
			sprite->play_once();
			map->game->sample->p1->teleport(dest);
      PLAY(Resources::Teleport());				
		}	

		if(map->game->get_t()==true)
		if(map->game->sample->p2->map_x(16)==x && map->game->sample->p2->map_y(16)==y && map->game->sample->p2->ported()==false)
		{
			sprite->play_once();
			map->game->sample->p2->teleport(dest);
      PLAY(Resources::Teleport());
		}

		if(map->game->sample->get_map_gameobject(x, y)->get_type()==MONK)
		{
			sprite->play_once();
			static_cast <Monk*> (map->game->sample->get_map_gameobject(x, y))->teleport(dest);
		}	
	}
}
void Maptile_teleporter::fit()
{
	list<Maptile*>::iterator it;
	for(it = map->tiles.begin(); it!=map->tiles.end(); ++it)
  {
  Maptile *m=*it;
	if(m->get_type()==TELEPORTER)
	{
		dest=static_cast <Maptile_teleporter*> (m);

		if(dest!=NULL)
		if(dest->get_id()==did)
		{
			connected=true;
			return;
		}
	}
  }	
	// we have no destination :)
	connected=false;
}